<?php
namespace Teknisa\FIN\Modules\ContaPagar\Services\Retorno;

//use Teknisa\Model\Financeiro\Entities\Errcnabp;
use Financeiro\Entities\Errcnabp;
//use Teknisa\Model\Geral\Entities\Banco;
use Geral\Entities\Banco;
use Geral\Util\Ambiente;
//use Teknisa\Model\Suprimentos\Entities\Antecipaforne;
use \Indeterminado\Entities\Antecipaforne;
//use Teknisa\Model\Financeiro\Entities\Boletpagar;
use Fiscal\Entities\Boletpagar;
//use Teknisa\Model\Financeiro\Entities\GeralPag;
use Financeiro\Entities\GeralPag;
use Financeiro\Entities\Ajbolpag;
//use Teknisa\Model\Financeiro\Entities\Ajbolpag;
use Geral\Entities\Contcorr;

abstract class LeitorCnab {

    protected $erros = array();
    protected $ocorrencias = array();
    protected $contlinha = 0;

    protected $cdempresa;

    protected $cdbanco;

    protected $arquivo;
    // Armazaneza objetoa do tipo \Retorno.
    protected $retornos = array();

    /** @var $retorno Retorno*/
    protected $retorno;
    protected $arquivoValido;

    /**
     * @return array
     */
    public function getRetornos(){
        $boletos = array();
        $boletos = array_filter($this->retornos, function($item){
          return strtoupper($item->getBoleto()) == 'BOLETO';
        });
        
        $ocorrencias = array();
        foreach ($boletos as $boleto) {
            $ocorrencias[] = array(
                'CDLINHA'      => str_pad(intval($boleto->getCdlinha()),4,'0',STR_PAD_LEFT),
                'DTVENCIMENTO' => $boleto->getDtvencimento(),
                'IDSITUCNABP'  => $boleto->getIdsitucnabp(),
                'VRACRESCIMO'  => $boleto->getVracrescimo(),
                'VRDESCONTO'   => $boleto->getVrdesconto(),
                'DTPAGAMENTO'  => $boleto->getDtpagamento(),
                'VRPAGO'       => $boleto->getVrpago(),
                'NOSSONUMERO'  => $boleto->getNossonumero(),
                'NRLANBOLPAG'  => $boleto->getNrlanbolpag(),
                'NMRAZSOCFORN' => $boleto->getNmrazsocforn(),
                'VRFINALBPAG'  => $boleto->getVrfinalpago(),
                'CDTPBAIXAPAG' => $boleto->getCdtpbaixapag(),
                'CDREDUCONT'   => $boleto->getCdreducont(),
                'CDFILIAL'     => $boleto->getCdfilial(),
                'SITUACAOBOLETO'     => $boleto->getSituacaoOk()
            );
        }
        return $ocorrencias;
    }

    /**
     * @return array
     */
    public function getErros(){
        return $this->erros;
    }

    public abstract function leArquivo($nrorg);

    /**
     * @param $cdlinha
     * @param $erro
     * @param bool $iderroGeral
     * @internal param $errom
     * @internal param $erro
     * @internal param $linha
     */
    protected function gravaErros($cdlinha, $erro, $geral = false){
        $this->erros[] = array('CDLINHA'  => str_pad(intval($cdlinha),4,'0',STR_PAD_LEFT),
                               'CDERRO'   => '',
                               'DSERRO'   => $erro,
                               'GERAL'   => $geral);
    }

    /**
     * @param $tipomovimento
     */
    protected function tipoMovimento($tipomovimento){

        $tipomovimento = trim($tipomovimento);
        if(empty($tipomovimento) and $tipomovimento != 0){
            self::gravaErros($this->contlinha,'Tipo de Movimento não Informado.');
        }
        $this->retorno->setTpmovimento($tipomovimento);

    }

    protected function setStatusArquivo($status){
        $this->arquivoValido = $status;
    }

    public function getStatusArquivo(){
        return $this->arquivoValido;
    }

    /**
     * @param $cdbanco
     */
    public function preparaOcorrencias($cdbanco, $nrorg){
        /** @var $retorno Retorno */
        foreach($this->retornos as $retorno){

            $ocorrencia = $retorno->getOcorrencia();
            $tamOcorrencia = strlen($retorno->getOcorrencia());

            for($i = 0;$i<$tamOcorrencia;$i+=2){
                $cderro = substr($ocorrencia,$i,2);
                if($cderro !== "  "){

                    /** @var $errcnabp Errcnabp */
                    $errcnabp = Errcnabp::findOneByCdbancoAndCderrcnabpAndNrorg($cdbanco, $cderro, $nrorg);

                    $dserro = $cderro;
                    if($errcnabp)
                        $dserro.= " - {$errcnabp->getDserrcnabp()}";
                        $this->erros[] = array('CDLINHA' => str_pad(intval($retorno->getCdlinha()),4,'0',STR_PAD_LEFT),
                                               'CDERRO'  => $cderro,
                                               'DSERRO'  => $dserro,
                                               'GERAL'  => false);
                }
            }
        }
    }

    /** Busca Tipo de Baixa para Pagamento no Boleto ou na Antecipação
     * @param $cdfilial
     * @param $nrlanbolpag
     * @param $nrorg
     * @return null
     */
    protected function getTipoBaixaPagamento($cdfilial, $nrlanbolpag, $nrorg){

        /** @var $boletpagar Boletpagar */
        $boletpagar = Boletpagar::findOneByCdfilialAndNrlanbolpagAndNrorg($cdfilial, $nrlanbolpag, $nrorg);

        if($boletpagar and $boletpagar->getCdtpbaixapag()){
            return $boletpagar->getCdtpbaixapag();
        }
        else{
            /** @var $antecipaforne Antecipaforne */
            $antecipaforne = Antecipaforne::findOneByNrlancantecipaAndCdfilialAndNrorg($cdfilial, $nrlanbolpag, $nrorg);
            if($antecipaforne and $antecipaforne->getCdtpbaixapag())
                return $antecipaforne->getCdtpbaixapag();
            else return null;
        }
    }

    /**
     * @param $cdfilial
     * @param $nrlanbolpag
     * @param $nrorg
     * @return null
     */
    protected function getReducont($cdfilial, $nrlanbolpag, $nrorg){
        /** @var $boletpagar Boletpagar */
        $boletpagar = Boletpagar::findOneByCdfilialAndNrlanbolpagAndNrorg($cdfilial, $nrlanbolpag, $nrorg);

        if($boletpagar and $boletpagar->getCdreducont()){
            return $boletpagar->getCdreducont();
        }
        else{
            /** @var $antecipaforne Antecipaforne */
            $antecipaforne = Antecipaforne::findOneByNrlancantecipaAndCdfilialAndNrorg($cdfilial, $nrlanbolpag, $nrorg);
            if($antecipaforne and $antecipaforne->getCdreducontpag())
                return $antecipaforne->getCdreducontpag();
            else return null;
        }
    }

    /**
     * @return mixed
     */
    private function getBanco(){

        $banco = Banco::findOneByCdbanco($this->cdbanco);
        return $banco;

    }

    public function validaBoletos($nrorg){

        $contasVerificadas = array();
        /** @var $retorno Retorno  */
        foreach($this->retornos as &$retorno){

            //Se for um boleto
            if($retorno->getBoleto()){

                $retorno->setSituacaoOk(true);

                if(!$retorno->getCdfilial() or !$retorno->getNrlanbolpag()){
                    self::gravaErros($retorno->getCdlinha(),'Código do título não informado no arquivo de retorno.');
                    $retorno->setSituacaoOk(false);
                }
                else {
                    /** @var $boletpagar Boletpagar */
                    $boletpagar = Boletpagar::findOneByCdfilialAndNrlanbolpagAndNrorg($retorno->getCdfilial(),
                                                                                      $retorno->getNrlanbolpag(),
                                                                                      $nrorg);
                    $this->validaEstadoTituloPagar($boletpagar, $retorno);
                    /*$vrpago = round($retorno->getVrpago(), 2);
                    if($boletpagar && $retorno->getIdsitucnabp() == '90'){
                        $vrfinal = round($retorno->getVrnominal() + $retorno->getVracrescimo() - $retorno->getVrdesconto(), 2);
                        if($vrpago != $vrfinal){
                            self::gravaErros($retorno->getCdlinha(), 'Valor final do boleto está diferente do valor cadastrado.');
                            $retorno->setSituacaoOk(false);
                        }
                    }*/

                    $this->validaAjusteTitulos($retorno, $nrorg);


                    if($boletpagar){
                        if(!$boletpagar->getCdreducont()){
                            self::gravaErros($retorno->getCdlinha(),'Título não possui conta corrente cadastrada.');
                            $retorno->setSituacaoOk(false);
                        }else{
                            self::validaContaCorrente($retorno, $boletpagar);
                        }
                    }

                    if ($boletpagar) {
                        if (!$boletpagar->getCdtpbaixapag()) {
                            self::gravaErros(
                                $retorno->getCdlinha(), 'Título não possui tipo de baixa a pagar cadastrado.'
                            );
                            $retorno->setSituacaoOk(false);
                        }
                        if(! $boletpagar->getNrcnabpagrem()){
                            self::gravaErros($retorno->getCdlinha(),'Título não está ligado a uma remessa.');
                            $retorno->setSituacaoOk(false);
                        }
                    }
                }
            }
        }
    }

    public function validaContaCorrente($retorno, $boletPagar){
        $contasVerificadas = array();
        if($retorno->getCdagencia() and $retorno->getCdconta()){
            
            $contacorrente = Contcorr::findOneByCdreducontAndNrorg($boletPagar->getCdreducont(), $boletPagar->getNrorg());
            
            if ($contacorrente->getCdagencia() && $contacorrente->getCdcontcorr()){
                
                /* Verificação de existência de DÍGITO */
                $banco = Banco::findOneByCdbancoAndNrorg($contacorrente->getCdbanco(), $contacorrente->getNrorg());
                $digitoAgencia   = (strpos($banco->getCdpictagen(), "-") > -1)?true:false;
                $digitoCcorrente = (strpos($banco->getCdpictcont(), "-") > -1)?true:false;
                
                $contaArquivo = str_pad($retorno->getCdconta(), 12, "0", STR_PAD_LEFT);
                if($digitoCcorrente)
                     $contaBoleto = str_pad(substr($contacorrente->getCdcontcorr(), 0, -1), 12, "0", STR_PAD_LEFT);
                else $contaBoleto = str_pad(substr($contacorrente->getCdcontcorr(), -12), 12, "0", STR_PAD_LEFT);
                
                $agenciaArquivo = str_pad($retorno->getCdagencia(), 5, "0", STR_PAD_LEFT);
                if($digitoAgencia)
                     $agenciaBoleto = str_pad(substr(trim($contacorrente->getCdagencia()), 0, -1), 5, "0", STR_PAD_LEFT);
                else $agenciaBoleto = str_pad(substr(trim($contacorrente->getCdagencia()), -5), 5, "0", STR_PAD_LEFT);
                
                if ($agenciaBoleto != $agenciaArquivo   ||
                    $contaBoleto != $contaArquivo){
                    self::gravaErros($retorno->getCdlinha(),
                                     "Conta corrente de débito {$this->cdbanco} /
                                     {$retorno->getCdagencia()} / {$retorno->getCdconta()}
                                     é diferente da conta corrente do título.");
                    $retorno->setSituacaoOk(false);
                }
            }
        }
    }

    public function validaEstadoTituloPagar($boletpagar, $retorno){
        if(! $boletpagar){
            self::gravaErros($retorno->getCdlinha(),'Título não Cadastrado.');
            $retorno->setSituacaoOk(false);
        }
        else{
            if($boletpagar->getNrbaixapag()){
                self::gravaErros($retorno->getCdlinha(),'Título encontra-se baixado.');
                $retorno->setSituacaoOk(false);
            }
            if($this->cdempresa != $boletpagar->getCdempresa()){
                self::gravaErros($retorno->getCdlinha(), 'Empresa do Título é Diferente da Empresa Informada.');
                $retorno->setSituacaoOk(false);
            }
        }
    }

    public function validaAjusteTitulos($retorno, $nrorg){
        if(round($retorno->getVracrescimo(),2)>0){
            /** @var $geralpag GeralPag */
            $geralpag = GeralPag::findOneByNrorg($nrorg);
            if(! $geralpag->getCdajacrepag()){
                self::gravaErros($retorno->getCdlinha(),
                                'Tipo de ajuste não está parametrizado.');
                                $retorno->setSituacaoOk(false);
            }
            else{
            $ajbolpag = Ajbolpag::findOneByCdfilialAndNrlanbolpagAndCdajuctpag
                                  ($retorno->getCdfilial(),
                                  $retorno->getNrlanbolpag(),
                                  $geralpag->getCdajacrepag());
                if($ajbolpag){
                    self::gravaErros($retorno->getCdlinha(),'Título já possui ajuste cadastrado para o
                                                             tipo de ajuste parametrizado');
                    $retorno->setSituacaoOk(false);
                }
            }
        }
        if(round($retorno->getVrdesconto(),2)>0){
            /** @var $geralpag GeralPag */
            $geralpag = GeralPag::findOneByNrorg($nrorg);
            if(! $geralpag->getCdajdescpag()){
                self::gravaErros($retorno->getCdlinha(),
                                 'Tipo de ajuste não está parametrizado .');
                                  $retorno->setSituacaoOk(false);
            }
            else{
                $ajbolpag = Ajbolpag::findOneByCdfilialAndNrlanbolpagAndCdajuctpag
                                      ($retorno->getCdfilial(),
                                      $retorno->getNrlanbolpag(),
                                      $geralpag->getCdajdescpag());
                if($ajbolpag){
                    self::gravaErros($retorno->getCdlinha(),'Título já possui ajuste cadastrado para o
                                                             tipo de ajuste parametrizado');
                    $retorno->setSituacaoOk(false);
                }
            }
        }
    }
}