var Bco21200_RelacaoSaldosContaCorrente_Service = function() {
  
  var self = this;
  
  this.buildDataSourceFilterFromFilterRow = function(filterRow) {
    var params = Util.clone(filterRow);
    return self.buildDataSourceFilterFromParams(self.buildParamsAccordingToFilter(params)); 
  };
  
  this.buildParamsAccordingToFilter = function(filterRow) {
    
    var params = {};
    
    //Empresa
    setParamsEmpresa(filterRow.CDEMPRESA, params);
    
    //Contcorr
    setParamsContcorr(filterRow.CDREDUCONT, params);
    
    //Data
    setParamsData(filterRow.DATA, params);
    
    return params;
    
  };
  
  this.buildDataSourceFilterFromParams = function (params) {
    
    var dataSourceFilter = [];
    
    for(var param in params) {
      dataSourceFilter.push(
        {
          "name": param,
          "operator": "=",
          "value": params[param]
        }
      );
    }
    
    return dataSourceFilter;
    
  };
  
  var setParamsEmpresa = function(CDEMPRESA, params) {
    if (CDEMPRESA instanceof Array) {
      if (CDEMPRESA.length > 0)
        params.CDEMPRESA = CDEMPRESA.join("_");
      else
        params.CDEMPRESA = 'T';
    } else {
      params.CDEMPRESA = 'T';
    }
  };
  
  var setParamsContcorr = function(CDREDUCONT, params) {
    if (CDREDUCONT instanceof Array) {
      if (CDREDUCONT.length > 0)
        params.CDREDUCONT = CDREDUCONT.join("_");
      else
        params.CDREDUCONT = 'T';
    } else {
      params.CDREDUCONT = 'T';
    } 
  };
  
  var setParamsData = function(DATA, params) {
    params.DATA = DATA;
  };
  
};

Configuration(function (ContextRegister){
    ContextRegister.register('Bco21200_RelacaoSaldosContaCorrente_Service', Bco21200_RelacaoSaldosContaCorrente_Service);
});

