package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ImpostoFederalApuracaoFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ImpostoFederalApuracaoPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ImpostoFederalApuracao extends TestBase {
    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    ImpostoFederalApuracaoFlows ImpostoFederalApuracaoFlows;
    ImpostoFederalApuracaoPage ImpostoFederalApuracaoPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {
        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ImpostoFederalApuracaoFlows = new ImpostoFederalApuracaoFlows();
        ImpostoFederalApuracaoPage =  new ImpostoFederalApuracaoPage();

        // Dados - Login
        String usuario = "operador24@AUTOMACAO_2184.com";
        String senha = "apresentacao";


        // Dados - Filtro Da Tela
        String tipodeapuracao = "Federal";
        String empresa = "HELA INGREDIENTES BRASIL";
        String imposto = "00 - ICMS";
        String inscricaoestadual = "148685946116";


        // Dados - Inserção do Mapa de Apuração
        String nomedomapa = "Apuração de IPI";
        String datafinal = "31/01/2021";

        // ..........Teste Da Tela..........


        // !!!! LOGIN !!!!

        loginPage.preenhcerUsuario(usuario);
        loginPage.preencherSenha(senha);
        loginPage.clicarEmLogin();

        // !!! MENU !!!

        MainFlows.navegarParaApuracaoDeImposto();


        // !!! FILTRO DE APURAÇÃO !!!

        ImpostoFederalApuracaoPage.clicarEmTipodeapuracao();
        ImpostoFederalApuracaoPage.clicarEmEmpresa();
        ImpostoFederalApuracaoPage.clicarEmImposto();
        ImpostoFederalApuracaoPage.clicarAplicarFiltro();

        // !!! ADICIONAR MAPA !!!

        ImpostoFederalApuracaoPage.clicarAdicionarMapa();

        // !!! CRIANDO MAPA DE APURAÇÃO !!!

        ImpostoFederalApuracaoPage.preencherNomedomapa(nomedomapa);
        ImpostoFederalApuracaoPage.clicarsalvarMapa();

        ImpostoFederalApuracaoPage.clicarEmMapaApuracao();
        ImpostoFederalApuracaoPage.clicarEmAcoes();
        ImpostoFederalApuracaoPage.clicarEmApurar();
        ImpostoFederalApuracaoPage.clicarOk();
        ImpostoFederalApuracaoPage.clicarEmAcoes();
        ImpostoFederalApuracaoPage.clicarEmBloquear();
        ImpostoFederalApuracaoPage.clicarOk();
        ImpostoFederalApuracaoPage.clicarEmAcoes();
        ImpostoFederalApuracaoPage.clicarEmDesbloquear();
        ImpostoFederalApuracaoPage.clicarOk();
        ImpostoFederalApuracaoPage.clicarEmAcoes();
        ImpostoFederalApuracaoPage.clicarEmCancelar();
        ImpostoFederalApuracaoPage.clicarEmExcluir();
        ImpostoFederalApuracaoPage.clicarEmSim();
        ImpostoFederalApuracaoPage.clicarOk();
    }
}
